package com.yihu.wlyy.service.survey;

import com.fasterxml.jackson.databind.JavaType;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.google.common.annotations.VisibleForTesting;
import com.mchange.v2.util.DoubleWeakHashMap;
import com.yihu.wlyy.entity.doctor.survey.*;
import com.yihu.wlyy.repository.doctor.*;
import com.yihu.wlyy.service.BaseService;
import com.yihu.wlyy.util.MapUtill;
import org.apache.commons.lang3.StringUtils;
import org.json.JSONArray;
import org.json.JSONObject;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.PageRequest;
import org.springframework.data.domain.Sort;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.bind.annotation.RequestParam;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.*;

/**
 * Created by Reece on 2017/3/14.
 */
@Service
@Transactional
public class PatientQuestionnaireService extends BaseService {
    @Autowired
    private SurveyQuestionnaireDao surveyQuestionnaireDao;
    @Autowired
    private SurveyQuestionnaireOptionsDao surveyQuestionnaireOptionsDao;
    @Autowired
    private SurveyDao surveyDao;
    @Autowired
    private SurveyUserDao surveyUserDao;
    @Autowired
    private SurveyOptionAnswersDao surveyOptionAnswersDao;
    @Autowired
    private SurveyAnswersDao surveyAnswersDao;
    @Autowired
    SurveyStatisticsDao surveyStatisticsDao;

    public JSONObject getSurveySummary(String patient, String id) throws Exception {
        JSONObject jsonObject = new JSONObject();
        Survey survey = surveyDao.findById(id);
//        int complete = surveyUserDao.findByPatient(patient, id);
        String title = survey.getTitle();
        String comment = survey.getSurveyComment();
        int status = survey.getStatus();
        jsonObject.put("title", title);
        jsonObject.put("comment", comment);
        jsonObject.put("status", status);
//        jsonObject.put("complete", complete);
        return jsonObject;
    }



   /* public void getQuestions(String id,Integer sort,Integer pageNo,Integer total,String nextCode){
        JSONObject json = new JSONObject();
        if(StringUtils.isEmpty(nextCode)){
            //不跳题
            if(total==null){
                total = surveyQuestionnaireDao.findTotalById(id);
            }
            sort = pageNo+1;
            json.put("total",total);
            json.put("sort",sort);
        }else{
            //跳题
            SurveyQuestionnaire question = surveyQuestionnaireDao.findByIdAndQstId(id,nextCode);

            total = total - (sort+1);
            json.put("total",total);
            json.put("sort",question.getSort());
        }
    }*/

    /**
     * @param id   问卷id
     * @param sort 当前问题的sort（初始为1）
     */
    public JSONObject getQuestions(String id, Integer sort) throws Exception {
        JSONObject jsonObject = new JSONObject();
        SurveyQuestionnaire question = null;
        //      该套问卷总题目数
        int total = surveyQuestionnaireDao.findTotalById(id);


        question = surveyQuestionnaireDao.findTotalByIdAndSort(id, sort);
        int sorts = question.getSort();

        String qstCode = question.getCode();
        String qstTitle = question.getTitle();
        int isRequired = question.getIsRequired();
        int type = question.getQuestionType();
//        int sorts = question.getSort();
        switch (type)

        {
            case 0:
                List<SurveyQuestionnaireOptions> options = surveyQuestionnaireOptionsDao.findById(qstCode);
                for (SurveyQuestionnaireOptions option : options) {
                    String content = option.getContent();
//                        可构造集合，返回选项特定值
                    if (option.getQuestionCodeNext() != null) {
                        String next = option.getQuestionCodeNext();
                        SurveyQuestionnaire sq = surveyQuestionnaireDao.findByIdAndQstId(id, next);
                        jsonObject.put("questionCodeNext", sq.getSort());
                    }

                }
                jsonObject.put("options", options);
                break;
            case 1:
                List<SurveyQuestionnaireOptions> optionss = surveyQuestionnaireOptionsDao.findById(qstCode);
                for (SurveyQuestionnaireOptions option : optionss) {
                    String content = option.getContent();
                    if (option.getQuestionCodeNext() != null) {
                        String next = option.getQuestionCodeNext();
                        SurveyQuestionnaire sq = surveyQuestionnaireDao.findByIdAndQstId(id, next);
                        jsonObject.put("questionCodeNext", sq.getSort());
                    }

                }
                int maxNum = question.getMaxNum();
                int minNum = question.getMinNum();
                jsonObject.put("maxNum", maxNum);
                jsonObject.put("minNum", minNum);
                jsonObject.put("options", optionss);
                break;
            case 2:
                if (question.getQuestionCodeNext() != null) {
                    String next = question.getQuestionCodeNext();
                    SurveyQuestionnaire sq = surveyQuestionnaireDao.findByIdAndQstId(id, next);
                    jsonObject.put("questionCodeNext", sq.getSort());
                }
                break;
        }
        jsonObject.put("qstCode", qstCode);
        jsonObject.put("qstTitle", qstTitle);
        jsonObject.put("isRequired", isRequired);
        jsonObject.put("type", type);
        jsonObject.put("sort", sorts);
//        题目数量是变量
        jsonObject.put("totalNum", total);

        return jsonObject;
    }
//==================================原来========================================
/*public JSONObject getQuestions(String id, Integer sort, Integer pageNo, Integer total, String nextCode) throws  Exception{
    JSONObject jsonObject = new JSONObject();
    SurveyQuestionnaire question = null;
    int sorts = 0;
    if (!StringUtils.isEmpty(nextCode)) {
//            跳题
//            question = surveyQuestionnaireDao.findByIdAndSort(id, Integer.parseInt(nextCode));
        question = surveyQuestionnaireDao.findByIdAndQstId(id,nextCode);
        sorts = question.getSort();
        total = total - (sorts -(sort + 1));
    } else {
//            不跳题
        if (total == null) {
            //      该套问卷总题目数
            total = surveyQuestionnaireDao.findTotalById(id);
        }
        question = surveyQuestionnaireDao.findTotalByIdAndSort(id, sort + 1);
        sorts = question.getSort();
    }

    String qstCode = question.getCode();
    String qstTitle = question.getTitle();
    int isRequired = question.getIsRequired();
    int type = question.getQuestionType();
//        int sorts = question.getSort();
    switch (type) {
        case 0:
            List<SurveyQuestionnaireOptions> options = surveyQuestionnaireOptionsDao.findById(qstCode);
            for (SurveyQuestionnaireOptions option : options) {
                String content = option.getContent();
//                        可构造集合，返回选项特定值
            }
            jsonObject.put("options", options);
            break;
        case 1:
            List<SurveyQuestionnaireOptions> optionss = surveyQuestionnaireOptionsDao.findById(qstCode);
            for (SurveyQuestionnaireOptions option : optionss) {
                String content = option.getContent();
            }
            int maxNum = question.getMaxNum();
            int minNum = question.getMinNum();
            jsonObject.put("maxNum", maxNum);
            jsonObject.put("minNum", minNum);
            jsonObject.put("options", optionss);
            break;
        case 2:
            String questionCodeNext = question.getQuestionCodeNext();
            jsonObject.put("questionCodeNext", questionCodeNext);
            break;
    }
    jsonObject.put("qstCode", qstCode);
    jsonObject.put("qstTitle", qstTitle);
    jsonObject.put("isRequired", isRequired);
    jsonObject.put("type", type);
    jsonObject.put("sort", sorts);
//        题目数量是变量
    jsonObject.put("totalNum", total);
    jsonObject.put("percent", (Math.round(((float) pageNo / total) * 100)) + "%");

    return jsonObject;
}*/
//    ======================================================================================

    public void saveAnswer(String patient, JSONObject jsonData) throws Exception {
        //解析json保存各种答案
        String surveyCode = jsonData.get("surveyCode").toString();
        Date createTime = new Date();
//        获取一维数组
        JSONArray questions = jsonData.getJSONArray("questions");
        for (int i = 0; i < questions.length(); i++) {
//            获取每一道题的信息
            JSONObject question = new JSONObject(questions.get(i).toString());

            String qstCode = question.get("qstCode").toString();
            int qstsort = Integer.parseInt(question.get("sort").toString());
            int type = Integer.parseInt(question.get("type").toString());
            String content = null;
            if (question.has("content")) {
                content = question.get("content").toString();
            }
            if (question.has("options")) {
//               获取每道题的所有选项
                JSONArray options = question.getJSONArray("options");
                for (int j = 0; j < options.length(); j++) {
                    JSONObject option = new JSONObject(options.get(j).toString());
                    String code = getCode();
                    String optionCode = option.get("optionCode").toString();
                    int optsort = Integer.parseInt(option.get("sort").toString());
                    String comment = null;
                    int haveComment = 0;
                    if (option.has("comment")) {
                        comment = option.get("comment").toString();
                        haveComment = 1;
                    }
//                 保存到选择题答案表
                    SurveyOptionAnswers optionAnswer = new SurveyOptionAnswers(code, patient, surveyCode, qstCode, optionCode, comment, type, createTime);
                    surveyOptionAnswersDao.save(optionAnswer);
/*//                选择题修改统计表数量
                    String statisticsCode = getCode();
                    String questionTitle = surveyQuestionnaireDao.findByIdAndQstId(surveyCode,qstCode).getTitle();
                    String optcontent = surveyQuestionnaireOptionsDao.findByRelationCode(surveyCode,qstCode,optionCode).getContent();
                    int amount =0;
                    ++amount;
                    SurveyStatistics statistics = new SurveyStatistics(statisticsCode, surveyCode, qstCode, questionTitle, optionCode, amount, optcontent, haveComment, type, qstsort, optsort);
                    surveyStatisticsDao.save(statistics);*/
                    surveyStatisticsDao.modifyAmount(surveyCode, qstCode, optionCode);
                }

            } else {
//               保存到问答题答案表
                String code = getCode();
                SurveyAnswers surveyAnswer = new SurveyAnswers(code, surveyCode, patient, qstCode, content, createTime);
                surveyAnswersDao.save(surveyAnswer);
//                问答题保存到统计表(只负责更改数量不负责创建)
                /*String statisticsCode = getCode();
                String questionTitle = surveyQuestionnaireDao.findByIdAndQstId(surveyCode,qstCode).getTitle();
                int amount = 0;
                ++amount;
                SurveyStatistics statistics = new SurveyStatistics(statisticsCode, surveyCode, qstCode, questionTitle, null, amount, null, null, type, qstsort, null);
                surveyStatisticsDao.save(statistics);*/
                surveyStatisticsDao.modifyAmount(surveyCode, qstCode);
            }

        }
    }

}
